#
# Copyright INRA-URGI 2009-2010
# 
# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software. You can use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
# 
# As a counterpart to the access to the source code and rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty and the software's author, the holder of the
# economic rights, and the successive licensors have only limited
# liability.
# 
# In this respect, the user's attention is drawn to the risks associated
# with loading, using, modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean that it is complicated to manipulate, and that also
# therefore means that it is reserved for developers and experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and, more generally, to use and operate it in the
# same conditions as regards security.
# 
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.
#

class TranscriptListIterator(object):
    """A class that iterates on a list of transcript"""

    def __init__(self, transcriptList, verbosity = 0):
        self.transcriptList = transcriptList
        self.verbosity = verbosity
        self.chromosomes = self.transcriptList.transcripts.keys()
        self.currentChromosome = 0
        self.currentTranscript = -1


    def __iter__(self):
        return self
    
    
    def next(self):
        self.currentTranscript += 1
        while True:
            if self.currentChromosome >= len(self.transcriptList.transcripts):
                raise StopIteration
            elif self.currentTranscript >= len(self.transcriptList.transcripts[self.chromosomes[self.currentChromosome]]):
                self.currentTranscript = 0
                self.currentChromosome += 1
            elif self.transcriptList.transcripts[self.chromosomes[self.currentChromosome]][self.currentTranscript] == None:
                self.currentTranscript += 1
            else:
                return self.transcriptList.transcripts[self.chromosomes[self.currentChromosome]][self.currentTranscript]
            
